//****************************************************************************
//  @DOC EXTERNE
//
//  @MODULE       MsgInfo.cpp
//
//  @DESCRIPTION  Implmentation de la classe <c MsgInfo>.<nl>
//	   
//  @AUTEUR       (c) V. Osele (osele@mygale.org)       Mai 1998
//
//  @COM          Prvenez moi, si vous faites des modifications.
//
//****************************************************************************

#include <strstrea.h>
#include <afxinet.h>

#include "MsgInfo.h"

//****************************************************************************
//
//  @METHODE       GetInfoFromString
//
//  @DESCRIPTION   Recupre les infos d'une chaine issue de la page
//                 Nomade.
//
//  @PARAMETRE     chaine de base
//  @PARAMETRE     titre de l'info
//  @PARAMETRE     texte de l'info
//
//  @RETOUR        faux si le dcoupage a loup compltement ou
//                 partiellement.<nl>
//                 vrai si tous les paramtres ont t trouvs
//
//****************************************************************************
bool MsgInfo::GetInfoFromString(CString& line,CString& titre,CString& info)
{
	titre.Empty();
	info.Empty();
	// recherche du titre
	CString avant,temp;
	if (!StringExtract(line,".shtml\">","</A>",avant,temp,line)) return false;
	StringHtmlToText(temp,titre);
	// recherche du texte
	if (!StringExtract(line,"<FONT SIZE=\"-1\">","</FONT>",avant,temp,line)) return false;
	temp.TrimLeft();
	temp.TrimRight();
	StringHtmlToText(temp,info);
	return true;
}

//****************************************************************************
//
//  @METHODE       GetMessage
//
//  @DESCRIPTION   retourne le mini-message a envoyer a partir de la page
//                 Nomade.
//
//  @PARAMETRE     type  rechercher (france,sant...)
//  @PARAMETRE     msg trouv
//
//  @RETOUR        0 si tout est ok
//                 -1 si problme de connexion
//                 -2 type non trouve
//                 -3 date non trouve (ville ok)
//
//****************************************************************************
int MsgInfo::GetMessage(const CString& type,CString& message)
{
	// le mini-msg ne doit pas depasser 160 car
	// a la limite, c'est pas cette fonction qui doit faire ca
	// mais la proc d'envoi du mini-msg (ou decoupage ne bout par ex)
	// seulement, je n'arrive pas a mettre un 0 terminal simplement
	// avec un ostrstream de taille variable !!
	#define MAX_MSG 160
	char msg[MAX_MSG+1];
	ostrstream result(msg,MAX_MSG);

	bool trouveDate=false;
	bool trouveInfo=false;

	CInternetSession session("SmsCenter");

	CInternetFile* file=NULL;
	CString adr("http://www.nomade.fr/contenu/infoendirect/afp/");

	try {
		file=(CInternetFile*)session.OpenURL(adr);
	} catch (CInternetException* pEx) {
		file=NULL;
		pEx->Delete();
	}
	if (file) {
		CString line;
		CString date;
		CString templine;
		// on lit ligne  ligne sachant qu'une ligne
		while (file->ReadString(line)) {
			if (line.Find("begin content")>=0) {
				// on lit jusqu'a avoir la phrase entire
				// car dfois, la ligne est coupe
				while (file->ReadString(templine)) {
					line+=templine;
					if (templine.Find("</B>")>=0) break;
				}
				CString avant,temp;
				StringExtract(line,"<B> "," </B> ",avant,temp,line);
				// rduction de la date
				// recherche jour
				int index=temp.Find(' ');
				temp=temp.Mid(index+1);
				index=temp.Find(' ');
				// jour
				date=temp.Left(index);
				date+='/';
				// recherche mois
				temp=temp.Mid(index+1);
				CString temp2;
				StringHtmlToText(temp,temp2);
				if      (temp2.Find("janvier")>=0) date+='1';
				else if (temp2.Find("fevrier")>=0) date+='2';
				else if (temp2.Find("mars")>=0) date+='3';
				else if (temp2.Find("avril")>=0) date+='4';
				else if (temp2.Find("mai")>=0) date+='5';
				else if (temp2.Find("juin")>=0) date+='6';
				else if (temp2.Find("juillet")>=0) date+='7';
				else if (temp2.Find("aout")>=0) date+='8';
				else if (temp2.Find("septembre")>=0) date+='9';
				else if (temp2.Find("octobre")>=0) date+="10";
				else if (temp2.Find("novembre")>=0) date+="11";
				else if (temp2.Find("decembre")>=0) date+="12";
				else date+="??";
				// anne
				date+='/';
				index=temp.Find(' ');
				temp=temp.Mid(index+1);
				date+=temp.Mid(2,2);
				// si on a russi a extraire quelque chose
				if (!date.IsEmpty()) {
					result << date << " " << endl;
					trouveDate=true;
				}
			}
			// La mto pour la ville choisie
			if (line.Find("pointafp.gif")>=0) {
				// concatenation de toute les infos
				while (file->ReadString(templine)) {
					line+=templine;
					if (templine.Find("</TABLE>")>=0) break;
				}
				// recherche des infos meteo pour la ville
				CString titre,info;
				GetInfoFromString(line,titre,info);
//				if (titre.Compare("Sante, Environnement")==0) {
//				if (titre.Compare("France")==0) {
				if (titre.Compare(type)==0) {
					result << titre << " : " << info << endl;
					trouveInfo=true;
				}
			}
		}
		file->Close();
		delete file;
	}
	else return -1;
/*
	CString msg=result.str();
	result.rdbuf()->freeze(0);
	return msg;
*/
	msg[result.pcount()]=0;
	message=CString(msg);
	if (!trouveInfo) return -2;
	if (!trouveDate) return -3;
	return 0;
}
