//****************************************************************************
//  @DOC EXTERNE
//
//  @MODULE       MsgMeteo.cpp
//
//  @DESCRIPTION  Implmentation de la classe <c MsgMeteo>.<nl>
//	   
//  @AUTEUR       (c) V. Osele (osele@mygale.org)       Mai 1998
//                Upgrade : bugmn / TheGFX / S-Stephen  Juin 1998

//
//  @COM          Prvenez moi, si vous faites des modifications.
//
//****************************************************************************

#include <strstrea.h>
#include <afxinet.h>

#include "MsgMeteo.h"

//****************************************************************************
//
//  CONSTANTES    Constante de classe
//
//  COMM          A complter
//
//****************************************************************************
const MsgMeteoVille MsgMeteo::LaRochelle("sudouest.shtml","Sud-Ouest - ","La Rochelle");
const MsgMeteoVille MsgMeteo::Cognac("sudouest.shtml","Sud-Ouest - ","Cognac");
const MsgMeteoVille MsgMeteo::Limoges("sudouest.shtml","Sud-Ouest - ","Limoges");
const MsgMeteoVille MsgMeteo::Bordeaux("sudouest.shtml","Sud-Ouest - ","Bordeaux");
const MsgMeteoVille MsgMeteo::Agen("sudouest.shtml","Sud-Ouest - ","Agen");
const MsgMeteoVille MsgMeteo::Montauban("sudouest.shtml","Sud-Ouest - ","Montauban");
const MsgMeteoVille MsgMeteo::Tarbes("sudouest.shtml","Sud-Ouest - ","Tarbes");
const MsgMeteoVille MsgMeteo::Auch("sudouest.shtml","Sud-Ouest - ","Auch");
const MsgMeteoVille MsgMeteo::Toulouse("sudouest.shtml","Sud-Ouest - ","Toulouse");
const MsgMeteoVille MsgMeteo::Biarritz("sudouest.shtml","Sud-Ouest - ","Biarritz");
const MsgMeteoVille MsgMeteo::Nancy("nordest.shtml","Nord-Est - ","Nancy");
const MsgMeteoVille MsgMeteo::Strasbourg("nordest.shtml","Nord-Est - ","Strasbourg");
const MsgMeteoVille MsgMeteo::Besancon("nordest.shtml","Nord-Est - ","Besancon");
const MsgMeteoVille MsgMeteo::Metz("nordest.shtml","Nord-Est - ","Metz");
const MsgMeteoVille MsgMeteo::Mulhouse ("nordest.shtml","Nord-Est - ","Mulhouse ");

//****************************************************************************
//
//  @METHODE       GetMeteoFromString
//
//  @DESCRIPTION   Recupre les infos mto d'une chaine issue de la page
//                 Nomade.
//
//  @PARAMETRE     chaine de base
//  @PARAMETRE     indication du temps
//  @PARAMETRE     temprature minimale
//  @PARAMETRE     temprature maximale
//
//  @RETOUR        faux si le dcoupage a loup compltement ou
//                 partiellement.<nl>
//                 vrai si tous les paramtres ont t trouvs
//
//****************************************************************************
bool MsgMeteo::GetMeteoFromString(CString &line,CString &temps,CString &min,CString &max)
{
	temps.Empty();
	min.Empty();
	max.Empty();
	// recherche du temps prsent
	CString avant;
	if (!StringExtract(line,"'","'",avant,temps,line)) return false;
	// recherche de la temp min/max
	// on se recale sur la colonne suivante
	if (!StringExtract(line,"<TD","",avant,min,line)) return false;
	if (!StringExtract(line,">","&#176",avant,min,line)) return false;
	if (!StringExtract(line,"/&nbsp;","&#176",avant,max,line)) return false;
	return true;
}

//****************************************************************************
//
//  @METHODE       GetMessage
//
//  @DESCRIPTION   retourne le mini-message a envoyer a partir de la page
//                 Nomade.
//
//  @PARAMETRE     ville  rechercher
//  @PARAMETRE     msg trouv
//
//  @RETOUR        0 si tout est ok
//                 -1 si problme de connexion
//                 -2 ville non trouve
//                 -3 date non trouve (ville ok)
//
//****************************************************************************
int MsgMeteo::GetMessage(const MsgMeteoVille& ville,CString& message)
{
	// le mini-msg ne doit pas depasser 160 car
	// a la limite, c'est pas cette fonction qui doit faire ca
	// mais la proc d'envoi du mini-msg (ou decoupage ne bout par ex)
	// seulement, je n'arrive pas a mettre un 0 terminal simplement
	// avec un ostrstream de taille variable !!
	#define MAX_MSG 160
	char msg[MAX_MSG+1];
	ostrstream result(msg,MAX_MSG);

	bool trouveDate=false;
	bool trouveVille=false;

	CInternetSession session("SmsCenter");

	CInternetFile* file=NULL;
	CString adr("http://www.nomade.fr/contenu/infoendirect/meteo/");
	adr+=ville.GetPage();

	try {
		file=(CInternetFile*)session.OpenURL(adr);
	} catch (CInternetException* pEx) {
		file=NULL;
		pEx->Delete();
	}
	if (file) {
		CString line;
		CString date;
		CString templine;
		// on lit ligne  ligne sachant qu'une ligne
		while (file->ReadString(line)) {
			if (line.Find(ville.GetEnteteDate())>=0) {
				// on lit jusqu'a avoir la phrase entire
				// car dfois, la ligne est coupe
				while (file->ReadString(templine)) {
					line+=templine;
					if (templine.Find("</B>")>=0) break;
				}
				CString avant;
				StringExtract(line,ville.GetEnteteDate(),"<",avant,date,line);
				// si on a russie a extraire quelque chose
				if (!date.IsEmpty()) {
					result << date << " " << endl;
					trouveDate=true;
				}
			}
			// La mto pour la ville choisie
			if (line.Find(ville.GetVille())>=0) {
				// concatenation de toute les infos
				while (file->ReadString(templine)) {
					line+=templine;
					if (templine.Find("</TR>")>=0) break;
				}
				// recherche des infos meteo pour la ville
				CString temps,min,max;
				GetMeteoFromString(line,temps,min,max);
				result << temps << " " << min << "/" << max << endl;
				GetMeteoFromString(line,temps,min,max);
				result << temps << " " << min << "/" << max << endl;
				trouveVille=true;
			}
		}
		file->Close();
		delete file;
	}
	else return -1;

/*
        CString msg=result.str();
        result.rdbuf()->freeze(0);
        return msg;
*/
	msg[result.pcount()]=0;
	message=CString(msg);
	if (!trouveVille) return -2;
	if (!trouveDate) return -3;
	return 0;
}
