//****************************************************************************
//  @DOC EXTERNE
//
//  @MODULE       MsgMeteoVille.cpp
//
//  @DESCRIPTION  Implmentation de la classe <c MsgMeteoVille>.<nl>
//	   
//  @AUTEUR       (c) V. Osele (osele@mygale.org)       Mai 1998
//
//  @COM          Prvenez moi, si vous faites des modifications.
//
//****************************************************************************

#include "MsgMeteoVille.h"

//****************************************************************************
//
//  @METHODE        MsgMeteoVille
//
//  @DESCRIPTION    Constructeur par dfaut
//
//****************************************************************************
MsgMeteoVille::MsgMeteoVille()
{
}

//****************************************************************************
//
//  @METHODE        MsgMeteoVille
//
//  @DESCRIPTION    Constructeur par copie
//
//  @PARAMETRE      MsgMeteoVille  copier
//
//****************************************************************************
MsgMeteoVille::MsgMeteoVille(const MsgMeteoVille& ville):
	_page(ville._page),
	_entete(ville._entete),
	_ville(ville._ville)
{
}

//****************************************************************************
//
//  @METHODE       MsgMeteoVille
//
//  @DESCRIPTION   Constructeur explicite
//
//  @PARAMETRE     page oube o se trouve l'info
//  @PARAMETRE     dlimitateur de date
//  @PARAMETRE     dlimitateur de ville
//
//  @EXEMPLE       Creation d'une constante pour la recherche sur Toulouse |
//
//  const MsgMeteoVille Toulouse("sudouest.html","Sud-Ouest - ","Toulouse");
//
//****************************************************************************
MsgMeteoVille::MsgMeteoVille(const CString &page,const CString enteteDate,const CString& ville):
	_page(page),
	_entete(enteteDate),
	_ville(ville)
{
}

//****************************************************************************
//
//  @METHODE       ~MsgMeteoVille
//
//  @DESCRIPTION   Destructeur
//
//****************************************************************************
MsgMeteoVille::~MsgMeteoVille()
{
}

//****************************************************************************
//
//  @METHODE       GetPage
//
//  @DESCRIPTION   rcupre page oube o se trouve l'info
//
//  @RETOUR        chaine donnant la page oube
//
//****************************************************************************
const char* MsgMeteoVille::GetPage() const
{
	return (const char*)_page;
}

//****************************************************************************
//
//  @METHODE       GetEnteteDate
//
//  @DESCRIPTION   dlimitateur de date ds cette page
//
//  @RETOUR        chaine permettant de reprer et dcouper la page html
//                 pour retrouver la date
//
//****************************************************************************
const char* MsgMeteoVille::GetEnteteDate() const
{
	return (const char* )_entete;
}

//****************************************************************************
//
//  @METHODE       GetVille
//
//  @DESCRIPTION   dlimitateur de la ville recherche
//
//  @RETOUR        chaine permettant de reprer et dcouper la page html
//                 pour retrouver la ville suivie des infos mto
//
//****************************************************************************
const char* MsgMeteoVille::GetVille() const
{
	return (const char* )_ville;
}
