//****************************************************************************
//  @DOC EXTERNE
//
//  @MODULE       Sms.cpp
//
//  @DESCRIPTION  Implmentation de la classe <c Sms>.<nl>
//	   
//  @AUTEUR       (c) V. Osele (osele@mygale.org)       Juin 1998
//
//  @COM          Prvenez moi, si vous faites des modifications.
//
//****************************************************************************

#include <afxinet.h>
//#ifdef TEST
//#include <iostream.h>
//#endif TEST

#include "Sms.h"

//****************************************************************************
//
//  @METHODE        Sms
//
//  @DESCRIPTION    Constructeur par dfaut
//
//****************************************************************************
Sms::Sms()
{
}

//****************************************************************************
//
//  @METHODE        Sms
//
//  @DESCRIPTION    Constructeur par copie
//
//  @PARAMETRE      sms  copier
//
//****************************************************************************
Sms::Sms(const Sms& sms):
	_tel(sms._tel),
	_msg(sms._msg)
{
}

//****************************************************************************
//
//  @METHODE       Sms
//
//  @DESCRIPTION   Constructeur explicite
//
//  @PARAMETRE     numro de tlphone du destinataire
//
//****************************************************************************
Sms::Sms(const CString& tel):
	_tel(tel)
{
}

//****************************************************************************
//
//  @METHODE       ~Sms
//
//  @DESCRIPTION   Destructeur
//
//****************************************************************************
Sms::~Sms()
{
}

//****************************************************************************
//
//  @METHODE       SetDestinataire
//
//  @DESCRIPTION   Positionne le numro de tlphone du destinataire
//
//  @TODO          Vrifier la validit du numro
//
//  @PARAMETRE     chaine reprsentant le numro
//
//****************************************************************************
void Sms::SetDestinataire(const CString& tel)
{
	_tel=tel;
}

//****************************************************************************
//
//  @METHODE       SetMessage
//
//  @DESCRIPTION   Positionne le message  envoyer
//
//  @COM           Le message est transform en interne chaine URL
//
//  @PARAMETRE     chaine reprsentant le message
//
//****************************************************************************
void Sms::SetMessage(const CString& msg)
{
	_msg=msg;
	URLEncode(_msg);
}

//****************************************************************************
//
//  @METHODE       Envoyer
//
//  @DESCRIPTION   Envoie le message
//
//  @COM           Le message est traduit sous forme url puis envoy
//
//  @PARAMETRE     msg  envoyer
//
//  @RETOUR        voir Envoyer()
//
//****************************************************************************
int Sms::Envoyer(const CString& msg)
{
	SetMessage(msg);
	return Envoyer();
}

//****************************************************************************
//
//  @METHODE       URLEncode
//
//  @DESCRIPTION   Transforme une chaine texte standard en chaine de type url
//
//  @COM           La traduction est ralise le plus simplement possible
//                 sans tenir compte du caractre Unicod de la chaine
//
//  @PARAMETRE     msg  transformer
//
//****************************************************************************
void Sms::URLEncode(CString& msg)
{
	CString result;
	bool isSpace=true;

	for (int i=0; i < msg.GetLength(); i++) {
		unsigned char c=msg[i];
		if (isspace(c)) {
			if (isSpace) continue;
			result=result+'+';
			isSpace=true;
			continue;
		}
		if (isalnum(c)) {
			result=result+msg[i];
			isSpace=false;
			continue;
		}
		CString temp;
		temp.Format("%%%2.2x",(int)c);
		result+=temp;
		isSpace=false;
	}
	msg=result;
}

