//****************************************************************************
//  @DOC EXTERNE
//
//  @MODULE       Sms.h
//
//  @DESCRIPTION  Dfinition de la classe <c Sms>.<nl>
//	   
//  @AUTEUR       (c) V. Osele (osele@mygale.org)       Mai 1998
//                Upgrade : bugmn / TheGFX / S-Stephen  Juin 1998
//
//  @COM          Prvenez moi, si vous faites des modifications.
//
//****************************************************************************

# ifndef _SMS_H_
# define _SMS_H_

// @CLASSE Classe de base permettant d'envoyer un mini-msg.<nl>
//         Il faut hriter de cette classe pour implmenter un
//         reseaux particulier ou une mthode d'envoi diffrente.  
class Sms
{
public:

// @TYPE Constructeur
	// @MEMBRE Constructeur par dfaut
	Sms();
	// @MEMBRE_ Constructeur par copie | 1
	Sms(const Sms& sms);
	// @MEMBRE_ Constructeur par explicite | 2
	Sms(const CString& tel);
// @TYPE Destructeur
	// @MEMBRE Destructeur
	virtual ~Sms();

// @TYPE Affectation
	// @MEMBRE Destinataire
	virtual void SetDestinataire(const CString& tel);
	// @MEMBRE Destinataire
	virtual void SetMessage(const CString& msg);

// @TYPE Oprations
	// @MEMBRE Envoie le message prdfini
	virtual int Envoyer(void) = 0;
	// @MEMBRE Envoie le message | 1
	virtual int Envoyer(const CString& msg);

protected:
// @DOC INTERNE
// @TYPE Utilitaires
	// @MEMBRE fonction convertissant un message texte sous forme url
	virtual void URLEncode(CString& msg);
// @TYPE Donnes membres
	// @MEMBRE numro de tel du receveur
	CString _tel;
	// @MEMBRE msg  envoyer
	CString _msg;
};

#endif _SMS_H_
