//****************************************************************************
//  @DOC EXTERNE
//
//  @MODULE       SmsCenter.cpp
//
//  @DESCRIPTION  Programme principale. "interface utilisateur" !!
//   
//  @AUTEUR       (c) V. Osele (osele@mygale.org)       Mai 1998
//
//  @VERSION      1.3
//
//  @COM          Prvenez moi, si vous faites des modifications.
//
//****************************************************************************

#include <afx.h>
#include <iostream.h>

#include "resource.h"

#include "Msg.h"
#include "MsgMeteoVille.h"
#include "MsgMeteo.h"
#include "MsgInfo.h"

#include "Sms.h"
#include "SmsSFR.h"
#include "SmsITI.h"
#include "SmsBGT.h"

int ExitMessage(int msg,int arg=0)
{
	CString msgerr;
	msgerr.Format(msg, arg);
	msgerr.AnsiToOem();
	cout << msgerr << endl;
	return -msg;
}

int main(int argc , char *argv[ ] )
{
/*  Fait disparaitre une appli
	#define RSP_SIMPLE_SERVICE 1
	DWORD (WINAPI *fpRsp)( DWORD , DWORD ); 

	(FARPROC&)fpRsp = GetProcAddress(GetModuleHandle("KERNEL32"), "RegisterServiceProcess");
	(*fpRsp)(GetCurrentProcessId(), RSP_SIMPLE_SERVICE);
*/
   
   // /rSFR /t'xxxxxxxxxx' /iMeteo /v'ville'
   // /rITI /t'xxxxxxxxxx' /iInfo /T'titre'
   // /rITI /t'xxxxxxxxxx' /iMessage /m"message a transmettre"
   CString telephone;
   const   MsgMeteoVille* ville=NULL;
   CString titre;
   CString LeMessage;
   bool    isMeteo = false;
   bool    isInfo  = false;
   bool    isMsg   = false;
   bool    isSFR   = false;
   bool    isITI   = false;
   HWND    console;
   
   while (--argc)
   {
      char* ptr = argv[argc];
      if (strlen(ptr) <= 1) continue;
      // au moins 2 chars
      if (ptr[0] != '/') continue;
      char type = ptr[1];
      ptr += 2;
      switch (type)
      {
      case 'h':
         SetConsoleTitle("SmsCenter");
         console=FindWindow("tty","SmsCenter");
         ShowWindow(console,SW_HIDE);
         break;

      case 'r':
         if      (strcmp(ptr,"SFR")          == 0) isSFR   = true;
         else if (strcmp(ptr,"ITI")          == 0) isITI   = true;
         break;

      case 't':
         telephone = ptr;
         break;

      case 'i':
         if      (strcmp(ptr,"Meteo")        == 0) isMeteo = true;
         else if (strcmp(ptr,"Info")         == 0) isInfo  = true;
         else if (strcmp(ptr,"Message")      == 0) isMsg   = true;
         break;

      case 'v':
         if      (strcmp(ptr,"La Rochelle")  == 0) ville = &MsgMeteo::LaRochelle;
         else if (strcmp(ptr,"Cognac")       == 0) ville = &MsgMeteo::Cognac;
         else if (strcmp(ptr,"Limoges")      == 0) ville = &MsgMeteo::Limoges;
         else if (strcmp(ptr,"Bordeaux")     == 0) ville = &MsgMeteo::Bordeaux;
         else if (strcmp(ptr,"Agen")         == 0) ville = &MsgMeteo::Agen;
         else if (strcmp(ptr,"Montauban")    == 0) ville = &MsgMeteo::Montauban;
         else if (strcmp(ptr,"Tarbes")       == 0) ville = &MsgMeteo::Tarbes;
         else if (strcmp(ptr,"Auch")         == 0) ville = &MsgMeteo::Auch;
         else if (strcmp(ptr,"Toulouse")     == 0) ville = &MsgMeteo::Toulouse;
         else if (strcmp(ptr,"Biarritz")     == 0) ville = &MsgMeteo::Biarritz;
         else if (strcmp(ptr,"Nancy")        == 0) ville = &MsgMeteo::Nancy;
         else if (strcmp(ptr,"Strasbourg")   == 0) ville = &MsgMeteo::Strasbourg;
         else if (strcmp(ptr,"Besancon")     == 0) ville = &MsgMeteo::Besancon;
         else if (strcmp(ptr,"Metz")         == 0) ville = &MsgMeteo::Metz;
         else if (strcmp(ptr,"Mulhouse")     == 0) ville = &MsgMeteo::Mulhouse;
         break;

      case 'T':
         if      (strcmp(ptr,"France")       == 0) titre = "France";
         else if (strcmp(ptr,"Francophonie") == 0) titre = "Monde francophone";
         else if (strcmp(ptr,"Etranger")     == 0) titre = "International";
         else if (strcmp(ptr,"Economie")     == 0) titre = "Economie";
         else if (strcmp(ptr,"Multimedia")   == 0) titre = "Telecom, Multimedia";
         else if (strcmp(ptr,"Culture")      == 0) titre = "Culture, spectacles";
         else if (strcmp(ptr,"Sport")        == 0) titre = "Sport";
         else if (strcmp(ptr,"Sante")        == 0) titre = "Sante, Environnement";
         break;

      case 'm':
         LeMessage = ptr;
         break;
      }
   }

   // test des rsultats
   if (!isSFR && !isITI)
      return ExitMessage(IDS_PB_ARG_RESEAU);

   if (telephone.IsEmpty())
      return ExitMessage(IDS_PB_ARG_PASTEL);

   if (isMsg)
   {
      if (LeMessage.IsEmpty())
         return ExitMessage(IDS_PB_ARG_PASMSG);
   }
   else if (!isMeteo && !isInfo)
      return ExitMessage(IDS_PB_ARG_PASINFO);
   
   int retour = 0;

   // recherche des infos et construction du msg
   CString msg;
   if (isMeteo)
   {
      if (ville == NULL) 
         return ExitMessage(IDS_PB_ARG_PASVILLE);
      
      retour = MsgMeteo::GetMessage(*ville, msg);
      if (retour != 0)
      {
         ExitMessage(IDS_PB_METEO, retour-10);
         return retour-10;
      }
   }

   if (isInfo)
   {
      if (titre.IsEmpty())
         return ExitMessage(IDS_PB_ARG_PASTITRE);
      
      retour = MsgInfo::GetMessage(titre, msg);
      if (retour != 0)
      {
         ExitMessage(IDS_PB_INFO, retour-20);
         return retour-20;
      }
   }

   if (isMsg)
   {
      msg = LeMessage;
   }

   // envoie du message
   if (isSFR)
   {
      SmsSFR sms(telephone);
      retour = sms.Envoyer(msg);
      if (retour != 0)
      {
         ExitMessage(IDS_PB_SENDSMS, retour-100);
         return retour-100;
      }
   }

   if (isITI)
   {
      SmsITI sms(telephone);
      retour = sms.Envoyer(msg);
      if (retour != 0)
      {
         ExitMessage(IDS_PB_SENDSMS, retour-100);
         return retour-100;
      }
   }

   
#ifdef TEST
	char c;
	cin >> c;
#endif TEST
	return ExitMessage(IDS_OK);

}
