//****************************************************************************
//  @DOC EXTERNE
//
//  @MODULE       SmsITI.cpp
//
//  @DESCRIPTION  Implmentation de la classe <c SmsITI>.<nl>
//	   
//  @AUTEUR       (c) V. Osele (osele@mygale.org)       Mai 1998
//                Upgrade : bugmn / TheGFX / S-Stephen  Juin 1998
//
//  @COM          Prvenez moi, si vous faites des modifications.
//
//****************************************************************************

#include <afxinet.h>
//#ifdef TEST
//#include <iostream.h>
//#endif TEST

#include "Sms.h"
#include "SmsITI.h"

//****************************************************************************
//
//  @METHODE        SmsITI
//
//  @DESCRIPTION    Constructeur par dfaut
//
//****************************************************************************
SmsITI::SmsITI():
	Sms()
{
}

//****************************************************************************
//
//  @METHODE        SmsITI
//
//  @DESCRIPTION    Constructeur par copie
//
//  @PARAMETRE      sms  copier
//
//****************************************************************************
SmsITI::SmsITI(const SmsITI& sms):
	Sms(sms)
{
}

//****************************************************************************
//
//  @METHODE       SmsITI
//
//  @DESCRIPTION   Constructeur explicite
//
//  @PARAMETRE     numro de tlphone du destinataire
//
//****************************************************************************
SmsITI::SmsITI(const CString& tel):
	Sms(tel)
{
}

//****************************************************************************
//
//  @METHODE       Envoyer
//
//  @DESCRIPTION   Envoie le mini-msg prpar  l'avance
//
//  @RETOUR        0  tout s'est bien pass
//                 -1 pas d'accs au serveur
//                 -2 requete invalide
//                 -3 telephone non dfinit
//                 -4 msg vide
//
//****************************************************************************
int SmsITI::Envoyer()
{
	if (_tel.IsEmpty()) return -3;
	if (_msg.IsEmpty()) return -4;

	CInternetSession session("SmsCenter");

	CHttpFile* file=NULL;

#ifdef TEST
	// TEST par analyseur de protocole HTTP (header/data)
	CString strServer ("www3.pair.com");
	CString strHeaders ("Accept: text/*\r\nUser-Agent: SmsCenter\r\nContent-Type: application/x-www-form-urlencoded\r\n");
	CString strObject ("webthing/docs/cgi/debug/headers.cgi");
#else TEST
	CString strServer ("sms.itineris.tm.fr");
	CString strHeaders ("Accept: text/*\r\nUser-Agent: SmsCenter\r\nContent-Type: application/x-www-form-urlencoded\r\n");
	CString strObject ("/cgi-bin/post-sms");
#endif TEST
	CString strData;
	strData.Format(
		"x=9&email=&y=11&number=%s&left=160&message=%s",
		(LPCSTR)_tel,(LPCSTR)_msg
		);

	INTERNET_PORT port=INTERNET_DEFAULT_HTTP_PORT;
	CHttpConnection* server=NULL;
	try {
		server=session.GetHttpConnection(strServer,port);

		file=server->OpenRequest(CHttpConnection::HTTP_VERB_POST,strObject);
	
	} catch (CInternetException* pEx) {
		file=NULL;
		pEx->Delete();
	}

	if (server==NULL) return -1;

	int result=0; // tout est ok
	if (file!=NULL) {
		file->AddRequestHeaders(strHeaders);

 		file->SendRequest(NULL,0,(void *)(LPCTSTR)strData,strData.GetLength());
//#ifdef TEST
//		CString line;
//		while (file->ReadString(line)) {
//			cout << line << endl;
//		}
//#endif TEST

		file->Close();
		delete file;
	}
	else result=-2;

	// server est != NULL
	server->Close();
	delete server;
	return result;
}
